commit a35de5977cf7091dc89ec50f91c49b222fc05773
Author: evenfri <evenfri256@gmail.com>
Date: Mon, 17 Aug 2026 17:34:34 +0800
initial commit
Diffstat:
22 files changed, 772 insertions(+), 0 deletions(-)
diff --git a/.gitignore b/.gitignore
@@ -0,0 +1,2 @@
+o.*
+*.o
diff --git a/boot.asm b/boot.asm
@@ -0,0 +1,39 @@
+bits 32
+
+mb_align equ 1 << 0
+mb_meminfo equ 1 << 1
+mb_flags equ mb_align | mb_meminfo
+mb_magic equ 0x1badb002 ; multiboot magic
+mb_checksum equ -(mb_magic + mb_flags)
+
+section .multiboot
+align 4
+ dd mb_magic
+ dd mb_flags
+ dd mb_checksum
+
+section .bss
+align 16
+stack_bottom:
+ resb 16384 ; 16 KiB
+stack_top:
+
+section .text
+global _start
+extern start_kernel
+
+_start:
+ ; setup stack
+ mov esp, stack_top
+
+ ; set arguments
+ push ebx ; multiboot_info_t mbi
+ push eax ; uint32_t magic
+
+ ; enter high-level kernel
+ call start_kernel
+
+ cli
+.loop:
+ hlt
+ jmp .loop
diff --git a/build/ar b/build/ar
@@ -0,0 +1,3 @@
+#!/bin/sh
+
+exec i686-elf-ar rsc "$@"
diff --git a/build/as b/build/as
@@ -0,0 +1,35 @@
+#!/bin/sh
+
+s_file=""
+o_file=""
+
+while [ $# -gt 0 ]; do
+ case "$1" in
+ -o)
+ o_file="$2"
+ shift 2
+ ;;
+ -o*)
+ o_file="${1#-o}"
+ shift 1
+ ;;
+ *.s|*.S|*.asm)
+ s_file="$1"
+ shift 1
+ ;;
+ *)
+ shift 1
+ ;;
+ esac
+done
+
+if [ -z "$s_file" ]; then
+ echo "as-wrapper error: no input assembly file provided" >&2
+ exit 1
+fi
+
+if [ -z "$o_file" ]; then
+ o_file="${s_file%.*}.o"
+fi
+
+exec nasm -f elf32 "$s_file" -o "$o_file"
diff --git a/build/cc b/build/cc
@@ -0,0 +1,11 @@
+#!/bin/sh
+
+exec i686-elf-gcc -c \
+ -O0 \
+ -nostdlib \
+ -ffreestanding \
+ -fno-builtin \
+ -Wall \
+ -Wextra \
+ -I"$kernel" \
+ "$@"
diff --git a/build/ld b/build/ld
@@ -0,0 +1,8 @@
+#!/bin/sh
+
+exec i686-elf-ld -T linker.ld \
+ -nostdlib \
+ -static \
+ -no-pie \
+ -o \
+ "$@" \
diff --git a/build/mkcommon b/build/mkcommon
@@ -0,0 +1,30 @@
+%.$o: $hfiles # don't combine with following %.$o rules
+
+%.$o:Q: %.c
+ echo $qcc $cflags $stem.c
+ $cc $cflags $stem.c
+
+%.$o:Q: %.cc
+ echo $qcc $cflags $stem.cc
+ $cc $cflags $stem.cc
+
+%.$o:Q: %.s
+ echo $qgas $gaflags $stem.s
+ $gas $gaflags $stem.s
+
+%.$o:Q: %.asm
+ echo $qas $aflags $stem.asm
+ $as $aflags $stem.asm
+
+nuke:V: nuke-common
+clean:V: clean-common
+%.clean:V: %.clean-common
+
+nuke-common:V:
+ rm -f *.[$os] [$os].out $cleanfiles $nukefiles
+
+clean-common:
+ rm -f *.[$os] [$os].out $cleanfiles
+
+%.clean-common:V:
+ rm -f $stem.[$os] [$os].$stem $stem.acid $stem
diff --git a/build/mkdirs b/build/mkdirs
@@ -0,0 +1,10 @@
+dir-%:QV:
+ for i in $dirs
+ do
+ (cd $i; mk $mkflags $stem)
+ done
+
+all:V: dir-all
+clean:V: dir-clean
+install:V: dir-install
+nuke:V: dir-nuke
diff --git a/build/mkhdr b/build/mkhdr
@@ -0,0 +1,23 @@
+o=o
+os=$o
+a=a
+
+qcc=CC
+qld=LD
+qas=AS
+qgas=AS
+qar=AR
+
+cc=cc
+ld=cc
+as=nasm
+gas=as
+ar=ar
+cflags=
+ldflags=
+aflags=
+gaflags=
+cleanfiles=
+nukefiles=
+lib=
+shortlib=
diff --git a/build/mklib b/build/mklib
@@ -0,0 +1,16 @@
+default:V: $lib
+
+$lib(%):N: %
+$lib:Q: ${ofiles:%=$lib(%)}
+ echo $qar $lib
+ $ar $lib $newmember
+
+&:nQ: &.$o
+ echo $qar $lib $stem.$o
+ $ar $lib $stem.$o
+
+all install:V: $lib
+
+cleanfiles=$cleanfiles $lib
+
+<$kernel/build/mkcommon
diff --git a/build/mkmany b/build/mkmany
@@ -0,0 +1,24 @@
+progs=${targ:%=$o.%}
+
+all:V: $progs
+
+$o.%: %.$o $ofiles $lib # ${shortlib:%=$libdir/lib%.a}
+ $ld -o $target $prereq $ldflags
+
+%.install:V: $bin/%
+
+$bin/%: $o.%
+ $install $o.$stem $bin/$stem
+
+many-install:V:
+ for i in $targ
+ do
+ mk $mkflags $i.install
+ done
+
+install:V: many-install
+
+cleanfiles=$cleanfiles $progs
+nukefiles=$nukefiles ${targ:%=$bin/%}
+
+<$kernel/build/mkcommon
diff --git a/build/mkone b/build/mkone
@@ -0,0 +1,18 @@
+prog=$o.$targ
+
+all:V: $prog
+
+$prog:Q: $ofiles $lib # ${shortlib:%=$libdir/lib%.a}
+ echo $qld $target
+ $ld $target $prereq $ldflags
+
+install:V: $targ.install
+%.install:V: $bin/%
+
+$bin/%: $o.%
+ $install $o.$stem $bin/$stem
+
+cleanfiles=$cleanfiles $prog
+nukefiles=$nukefiles $bin/$targ
+
+<$kernel/build/mkcommon
diff --git a/dat.h b/dat.h
@@ -0,0 +1,32 @@
+#ifndef dat_h
+#define dat_h
+
+#include "oxytoxin.h"
+
+/* vga */
+#define vga_width 80
+#define vga_height 25
+#define vga_start 0xb8000
+#define vga_ctrl 0x3d4
+#define vga_data 0x3d5
+
+enum vga_color {
+ vga_color_black = 0,
+ vga_color_blue = 1,
+ vga_color_green = 2,
+ vga_color_cyan = 3,
+ vga_color_red = 4,
+ vga_color_magenta = 5,
+ vga_color_brown = 6,
+ vga_color_light_grey = 7,
+ vga_color_dark_grey = 8,
+ vga_color_light_blue = 9,
+ vga_color_light_green = 10,
+ vga_color_light_cyan = 11,
+ vga_color_light_red = 12,
+ vga_color_light_magenta = 13,
+ vga_color_light_brown = 14,
+ vga_color_white = 15,
+};
+
+#endif /* dat_h */
diff --git a/fns.h b/fns.h
@@ -0,0 +1,43 @@
+#ifndef fns_h
+#define fns_h
+
+#include "oxytoxin.h"
+
+/* input/output ports */
+static inline void io_wait() {
+ asm volatile ("outb %%al, $0x80" : : "a"(0));
+}
+
+static inline void outb(uint16_t port, uint8_t val) {
+ asm volatile ("outb %0, %1" : : "a"(val), "Nd"(port));
+}
+
+static inline uint8_t inb(uint16_t port) {
+ uint8_t ret;
+ asm volatile ("inb %1, %0" : "=a"(ret) : "Nd"(port));
+ return ret;
+}
+
+/* vga */
+static inline uint8_t vga_entry_color(enum vga_color fg, enum vga_color bg) {
+ return fg | bg << 4;
+}
+
+static inline uint16_t vga_entry(unsigned char uc, uint8_t color) {
+ return (uint16_t) uc | (uint16_t) color << 8;
+}
+
+/* vga cursor */
+void vga_cursor_enable(uint8_t s, uint8_t e);
+void vga_cursor_disable(void);
+void vga_cursor_update(int x, int y);
+uint16_t vga_cursor_get_pos(void);
+
+/* tty */
+void tty_init(void);
+void tty_set_color(uint8_t color);
+void tty_clear(void);
+void tty_putchar(char c);
+void tty_write(const char* data, size_t size);
+
+#endif /* fns_h */
diff --git a/init.c b/init.c
@@ -0,0 +1,14 @@
+#include "oxytoxin.h"
+
+void start_kernel(uint32_t magic, multiboot_info_t *mbi) {
+ (void)magic;
+ (void)mbi;
+
+ tty_init();
+
+ tty_write("hello, oxytoxin kernel\n", 23);
+
+ while (1) {
+ asm volatile ("hlt");
+ }
+}
diff --git a/linker.ld b/linker.ld
@@ -0,0 +1,26 @@
+ENTRY(_start)
+
+SECTIONS {
+ . = 1M;
+
+ .text BLOCK(4K) : ALIGN(4K) {
+ *(.multiboot)
+ *(.text)
+ }
+
+ /* ro data */
+ .rodata BLOCK(4K) : ALIGN(4K) {
+ *(.rodata)
+ }
+
+ /* rw data */
+ .data BLOCK(4K) : ALIGN(4K) {
+ *(.data)
+ }
+
+ /* rw data and stack */
+ .bss BLOCK(4K) : ALIGN(4K) {
+ *(COMMON)
+ *(.bss)
+ }
+}
diff --git a/mkfile b/mkfile
@@ -0,0 +1,24 @@
+kernel = `{pwd}
+<$kernel/build/mkhdr
+<$kernel/build/mkdirs
+
+as = ./build/as
+cc = ./build/cc
+ld = ./build/ld
+ar = ./build/ar
+
+ldflags =
+dirs =
+
+ofiles = boot.$o \
+ vga.$o \
+ tty.$o \
+ init.$o \
+
+hfiles = dat.h \
+ fns.h \
+ oxytoxin.h \
+
+targ = oxytoxin
+
+<$kernel/build/mkone
diff --git a/multiboot.h b/multiboot.h
@@ -0,0 +1,274 @@
+/* multiboot.h - Multiboot header file. */
+/* Copyright (C) 1999,2003,2007,2008,2009,2010 Free Software Foundation, Inc.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to
+ * deal in the Software without restriction, including without limitation the
+ * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
+ * sell copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL ANY
+ * DEVELOPER OR DISTRIBUTOR BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
+ * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR
+ * IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+ */
+
+#ifndef MULTIBOOT_HEADER
+#define MULTIBOOT_HEADER 1
+
+/* How many bytes from the start of the file we search for the header. */
+#define MULTIBOOT_SEARCH 8192
+#define MULTIBOOT_HEADER_ALIGN 4
+
+/* The magic field should contain this. */
+#define MULTIBOOT_HEADER_MAGIC 0x1BADB002
+
+/* This should be in %eax. */
+#define MULTIBOOT_BOOTLOADER_MAGIC 0x2BADB002
+
+/* Alignment of multiboot modules. */
+#define MULTIBOOT_MOD_ALIGN 0x00001000
+
+/* Alignment of the multiboot info structure. */
+#define MULTIBOOT_INFO_ALIGN 0x00000004
+
+/* Flags set in the ’flags’ member of the multiboot header. */
+
+/* Align all boot modules on i386 page (4KB) boundaries. */
+#define MULTIBOOT_PAGE_ALIGN 0x00000001
+
+/* Must pass memory information to OS. */
+#define MULTIBOOT_MEMORY_INFO 0x00000002
+
+/* Must pass video information to OS. */
+#define MULTIBOOT_VIDEO_MODE 0x00000004
+
+/* This flag indicates the use of the address fields in the header. */
+#define MULTIBOOT_AOUT_KLUDGE 0x00010000
+
+/* Flags to be set in the ’flags’ member of the multiboot info structure. */
+
+/* is there basic lower/upper memory information? */
+#define MULTIBOOT_INFO_MEMORY 0x00000001
+/* is there a boot device set? */
+#define MULTIBOOT_INFO_BOOTDEV 0x00000002
+/* is the command-line defined? */
+#define MULTIBOOT_INFO_CMDLINE 0x00000004
+/* are there modules to do something with? */
+#define MULTIBOOT_INFO_MODS 0x00000008
+
+/* These next two are mutually exclusive */
+
+/* is there a symbol table loaded? */
+#define MULTIBOOT_INFO_AOUT_SYMS 0x00000010
+/* is there an ELF section header table? */
+#define MULTIBOOT_INFO_ELF_SHDR 0X00000020
+
+/* is there a full memory map? */
+#define MULTIBOOT_INFO_MEM_MAP 0x00000040
+
+/* Is there drive info? */
+#define MULTIBOOT_INFO_DRIVE_INFO 0x00000080
+
+/* Is there a config table? */
+#define MULTIBOOT_INFO_CONFIG_TABLE 0x00000100
+
+/* Is there a boot loader name? */
+#define MULTIBOOT_INFO_BOOT_LOADER_NAME 0x00000200
+
+/* Is there a APM table? */
+#define MULTIBOOT_INFO_APM_TABLE 0x00000400
+
+/* Is there video information? */
+#define MULTIBOOT_INFO_VBE_INFO 0x00000800
+#define MULTIBOOT_INFO_FRAMEBUFFER_INFO 0x00001000
+
+#ifndef ASM_FILE
+
+typedef unsigned char multiboot_uint8_t;
+typedef unsigned short multiboot_uint16_t;
+typedef unsigned int multiboot_uint32_t;
+typedef unsigned long long multiboot_uint64_t;
+
+struct multiboot_header
+{
+ /* Must be MULTIBOOT_MAGIC - see above. */
+ multiboot_uint32_t magic;
+
+ /* Feature flags. */
+ multiboot_uint32_t flags;
+
+ /* The above fields plus this one must equal 0 mod 2^32. */
+ multiboot_uint32_t checksum;
+
+ /* These are only valid if MULTIBOOT_AOUT_KLUDGE is set. */
+ multiboot_uint32_t header_addr;
+ multiboot_uint32_t load_addr;
+ multiboot_uint32_t load_end_addr;
+ multiboot_uint32_t bss_end_addr;
+ multiboot_uint32_t entry_addr;
+
+ /* These are only valid if MULTIBOOT_VIDEO_MODE is set. */
+ multiboot_uint32_t mode_type;
+ multiboot_uint32_t width;
+ multiboot_uint32_t height;
+ multiboot_uint32_t depth;
+};
+
+/* The symbol table for a.out. */
+struct multiboot_aout_symbol_table
+{
+ multiboot_uint32_t tabsize;
+ multiboot_uint32_t strsize;
+ multiboot_uint32_t addr;
+ multiboot_uint32_t reserved;
+};
+typedef struct multiboot_aout_symbol_table multiboot_aout_symbol_table_t;
+
+/* The section header table for ELF. */
+struct multiboot_elf_section_header_table
+{
+ multiboot_uint32_t num;
+ multiboot_uint32_t size;
+ multiboot_uint32_t addr;
+ multiboot_uint32_t shndx;
+};
+typedef struct multiboot_elf_section_header_table multiboot_elf_section_header_table_t;
+
+struct multiboot_info
+{
+ /* Multiboot info version number */
+ multiboot_uint32_t flags;
+
+ /* Available memory from BIOS */
+ multiboot_uint32_t mem_lower;
+ multiboot_uint32_t mem_upper;
+
+ /* "root" partition */
+ multiboot_uint32_t boot_device;
+
+ /* Kernel command line */
+ multiboot_uint32_t cmdline;
+
+ /* Boot-Module list */
+ multiboot_uint32_t mods_count;
+ multiboot_uint32_t mods_addr;
+
+ union
+ {
+ multiboot_aout_symbol_table_t aout_sym;
+ multiboot_elf_section_header_table_t elf_sec;
+ } u;
+
+ /* Memory Mapping buffer */
+ multiboot_uint32_t mmap_length;
+ multiboot_uint32_t mmap_addr;
+
+ /* Drive Info buffer */
+ multiboot_uint32_t drives_length;
+ multiboot_uint32_t drives_addr;
+
+ /* ROM configuration table */
+ multiboot_uint32_t config_table;
+
+ /* Boot Loader Name */
+ multiboot_uint32_t boot_loader_name;
+
+ /* APM table */
+ multiboot_uint32_t apm_table;
+
+ /* Video */
+ multiboot_uint32_t vbe_control_info;
+ multiboot_uint32_t vbe_mode_info;
+ multiboot_uint16_t vbe_mode;
+ multiboot_uint16_t vbe_interface_seg;
+ multiboot_uint16_t vbe_interface_off;
+ multiboot_uint16_t vbe_interface_len;
+
+ multiboot_uint64_t framebuffer_addr;
+ multiboot_uint32_t framebuffer_pitch;
+ multiboot_uint32_t framebuffer_width;
+ multiboot_uint32_t framebuffer_height;
+ multiboot_uint8_t framebuffer_bpp;
+#define MULTIBOOT_FRAMEBUFFER_TYPE_INDEXED 0
+#define MULTIBOOT_FRAMEBUFFER_TYPE_RGB 1
+#define MULTIBOOT_FRAMEBUFFER_TYPE_EGA_TEXT 2
+ multiboot_uint8_t framebuffer_type;
+ union
+ {
+ struct
+ {
+ multiboot_uint32_t framebuffer_palette_addr;
+ multiboot_uint16_t framebuffer_palette_num_colors;
+ };
+ struct
+ {
+ multiboot_uint8_t framebuffer_red_field_position;
+ multiboot_uint8_t framebuffer_red_mask_size;
+ multiboot_uint8_t framebuffer_green_field_position;
+ multiboot_uint8_t framebuffer_green_mask_size;
+ multiboot_uint8_t framebuffer_blue_field_position;
+ multiboot_uint8_t framebuffer_blue_mask_size;
+ };
+ };
+};
+typedef struct multiboot_info multiboot_info_t;
+
+struct multiboot_color
+{
+ multiboot_uint8_t red;
+ multiboot_uint8_t green;
+ multiboot_uint8_t blue;
+};
+
+struct multiboot_mmap_entry
+{
+ multiboot_uint32_t size;
+ multiboot_uint64_t addr;
+ multiboot_uint64_t len;
+#define MULTIBOOT_MEMORY_AVAILABLE 1
+#define MULTIBOOT_MEMORY_RESERVED 2
+#define MULTIBOOT_MEMORY_ACPI_RECLAIMABLE 3
+#define MULTIBOOT_MEMORY_NVS 4
+#define MULTIBOOT_MEMORY_BADRAM 5
+ multiboot_uint32_t type;
+} __attribute__((packed));
+typedef struct multiboot_mmap_entry multiboot_memory_map_t;
+
+struct multiboot_mod_list
+{
+ /* the memory used goes from bytes ’mod_start’ to ’mod_end-1’ inclusive */
+ multiboot_uint32_t mod_start;
+ multiboot_uint32_t mod_end;
+
+ /* Module command line */
+ multiboot_uint32_t cmdline;
+
+ /* padding to take it to 16 bytes (must be zero) */
+ multiboot_uint32_t pad;
+};
+typedef struct multiboot_mod_list multiboot_module_t;
+
+/* APM BIOS info. */
+struct multiboot_apm_info
+{
+ multiboot_uint16_t version;
+ multiboot_uint16_t cseg;
+ multiboot_uint32_t offset;
+ multiboot_uint16_t cseg_16;
+ multiboot_uint16_t dseg;
+ multiboot_uint16_t flags;
+ multiboot_uint16_t cseg_len;
+ multiboot_uint16_t cseg_16_len;
+ multiboot_uint16_t dseg_len;
+};
+
+#endif /* ! ASM_FILE */
+
+#endif /* ! MULTIBOOT_HEADER */
diff --git a/oxytoxin.h b/oxytoxin.h
@@ -0,0 +1,11 @@
+#ifndef oxytoxin_h
+#define oxytoxin_h
+
+#include <stddef.h>
+#include <stdint.h>
+
+#include "multiboot.h"
+#include "dat.h"
+#include "fns.h"
+
+#endif /* oxytoxin_h */
diff --git a/qemu.sh b/qemu.sh
@@ -0,0 +1,9 @@
+#!/bin/sh
+
+set -e
+kernel_bin="./o.oxytoxin"
+mem="16M"
+
+exec qemu-system-i386 \
+ -m "$mem" \
+ -kernel "$kernel_bin" \
diff --git a/tty.c b/tty.c
@@ -0,0 +1,85 @@
+#include "oxytoxin.h"
+
+size_t tty_row;
+size_t tty_column;
+uint8_t tty_color;
+uint16_t* tty_buffer = (uint16_t*)vga_start;
+
+void tty_set_color(uint8_t color) {
+ tty_color = color;
+}
+
+void tty_putentryat(char c, uint8_t color, size_t x, size_t y) {
+ const size_t index = y * vga_width + x;
+ tty_buffer[index] = vga_entry(c, color);
+}
+
+void tty_clear(void) {
+ tty_row = 0;
+ tty_column = 0;
+
+ for (size_t y = 0; y < vga_height; y++) {
+ for (size_t x = 0; x < vga_width; x++) {
+ const size_t index = y * vga_width + x;
+ tty_buffer[index] = vga_entry(' ', tty_color);
+ }
+ }
+ vga_cursor_update(tty_column, tty_row);
+}
+
+void tty_init(void) {
+ vga_cursor_enable(14, 15);
+ tty_color = vga_entry_color(vga_color_light_grey, vga_color_black);
+ tty_clear();
+}
+
+void tty_scroll(void) {
+ /* move lines to line-1 */
+ for (int row = 1; row < vga_height; row++) {
+ for (int col = 0; col < vga_width; col++) {
+ size_t src_index = row * vga_width + col;
+ size_t dst_index = (row - 1) * vga_width + col;
+ tty_buffer[dst_index] = tty_buffer[src_index];
+ }
+ }
+ /* clear last line*/
+ uint16_t blank = ' ' | (tty_color << 8);
+ for (int col = 0; col < vga_width; col++) {
+ size_t index = (vga_height - 1) * vga_width + col;
+ tty_buffer[index] = blank;
+ }
+}
+void tty_putchar(char c) {
+ if(c == '\n') {
+ tty_row++;
+ tty_column = 0;
+
+ if (tty_row >= vga_height) {
+ tty_scroll();
+ tty_row = vga_height - 1;
+ }
+ } else if(c == '\b') {
+ if (tty_column > 0) {
+ tty_column--;
+ tty_putentryat(' ', tty_color, tty_column, tty_row);
+ }
+ } else {
+ tty_putentryat(c, tty_color, tty_column, tty_row);
+ if (++tty_column == vga_width) {
+ tty_column = 0;
+ if (++tty_row == vga_height) {
+ tty_scroll();
+ tty_row = vga_height - 1;
+ }
+ }
+ }
+
+ vga_cursor_update(tty_column, tty_row);
+}
+
+void tty_write(const char* data, size_t size) {
+ for(size_t i = 0; i < size; i++) {
+ tty_putchar(data[i]);
+ }
+}
+
diff --git a/vga.c b/vga.c
@@ -0,0 +1,35 @@
+#include "oxytoxin.h"
+
+void vga_cursor_enable(uint8_t s, uint8_t e) {
+ outb(vga_ctrl, 0x0a);
+ outb(vga_data, (inb(vga_data) & 0xc0) | s);
+
+ outb(vga_ctrl, 0x0b);
+ outb(vga_data, (inb(vga_data) & 0xe0) | e);
+}
+
+void vga_cursor_disable(void) {
+ outb(vga_ctrl, 0x0a);
+ outb(vga_data, 0x20);
+}
+
+void vga_cursor_update(int x, int y) {
+ uint16_t pos = y * vga_width + x;
+ outb(vga_ctrl, 0x0f);
+ outb(vga_data, (uint8_t) (pos & 0xff));
+
+ outb(vga_ctrl, 0x0e);
+ outb(vga_data, (uint8_t) ((pos >> 8) & 0xff));
+}
+
+uint16_t vga_cursor_get_pos(void) {
+ uint16_t pos = 0;
+ outb(vga_ctrl, 0x0f);
+
+ pos |= inb(0x3d5);
+ outb(vga_ctrl, 0x0e);
+
+ pos |= ((uint16_t)inb(0x3d5) << 8);
+ return pos;
+}
+